program RPN;
(*$N+,E+*)

uses dos, crt;

const
   mf=6;

type
   funzioni=function(x: extended): extended;
   ppoo=record
           value: string[5];
           tipo: byte
        end;
   poo=array[0..20] of ppoo;
   pstack=array[0..7] of ppoo;
   ppp=record
          ps, po: poo;
          psc, poc: byte
       end;
   p=array[0..7] of ppp;
   fun=array[1..mf] of string;
   validset=set of byte;
   tmpdata=array[0..10] of word;

const
   validcode: validset=[200,205,206,207];
   funzname: fun=('sin','cos','abs','chs','int','sqrt');
   fc: byte=1;
   pa: byte=0;
   sc: byte=0;

var
   w: word;
   fine: boolean;
   funz, funzbis: string;
   pp: p;
   l: byte;
   cmd: ppoo;
   valid: validset;
   f: text;
   ff: file;
   obj: pointer;
   tmp: tmpdata;
   funzione: funzioni;
   x: extended;
   fstack: pstack;

procedure error;
begin
   writeln(funzbis);
   gotoxy(fc,wherey);
   writeln('^');
   readln;
   halt
end;

function search: shortint;
var
   k: byte;
   o: boolean;
begin
   if sc=0 then begin
      search:=-1;
      exit
   end;
   o:=false;
   k:=0;
   repeat
      with pp[0] do
         if (po[pa].tipo=fstack[k].tipo) and
            (po[pa].value=fstack[k].value)
               then o:=true
                  else inc(k)
   until (k=sc) or o;
   search:=sc-k-1
end;

procedure searchvalid(var c: ppoo);
var
   k: byte;
   o: boolean;
   v: word;
   i: integer;
begin
   with c do begin
      if funz='' then begin
         tipo:=5;
         exit
      end;
      case funz[1] of
         '0'..'9': begin
                      val(funz,v,i);
                      if i=0 then l:= length(funz) else l:=i-1;
                      tipo:=1
                   end;
         '(': begin
                 tipo:=2;
                 l:=1
              end;
         ')': begin
                 tipo:=7;
                 l:=1
              end;
         '+','-','*','/': begin
                             tipo:=3;
                             l:=1
                          end;
         'x', 'X': begin
                      tipo:=6;
                      l:=1
                   end
         else begin
                 k:=1;
                 o:=false;
                 tipo:=0;
                 repeat
                    if copy(funz,1,length(funzname[k]))=funzname[k] then begin
                       tipo:=4;
                       l:=length(funzname[k]);
                       o:=true
                    end;
                    inc(k)
                 until (k=mf+1) or o;
                 if tipo=0 then error
              end;
      end;
      value:=copy(funz,1,l);
      delete(funz,1,l)
   end
end;

function oprec(o: char): shortint;
begin
   case o of
      '+','-': oprec:=-4;
      '*','/': oprec:=-2
   end
end;

procedure data;
begin
   with pp[pa] do begin
      po[poc]:=cmd;
      inc(poc)
   end;
   valid:=[3,5,7]
end;

procedure parchiusa;
var
   k: byte;
begin
   if pa=0 then error;
   with pp[pa] do
      if psc<>0 then begin
         for k:=psc-1 downto 0 do
            po[poc-k+psc-1]:=ps[k];
         inc(poc,psc)
   end;
   for k:=0 to pp[pa].poc-1 do pp[pa-1].po[pp[pa-1].poc+k]:=pp[pa].po[k];
   inc(pp[pa-1].poc,pp[pa].poc);
   dec(pa);
   valid:=[3,5,7]
end;

procedure paraperta;
begin
   inc(pa);
   with pp[pa] do begin
      poc:=0;
      psc:=0
   end;
   valid:=[1,2,4,5,6]
end;

procedure opercontr;
begin
   with pp[pa] do
      if psc=0 then begin
         ps[0]:=cmd;
         psc:=1
      end else
         if oprec(cmd.value[1])>oprec(ps[psc-1].value[1]) then begin
            ps[psc]:=cmd;
            inc(psc)
         end else begin
            po[poc]:=ps[psc-1];
            inc(poc);
            ps[psc-1]:=cmd
         end;
   valid:=[1,2,5,6]
end;

procedure opermin;
begin
   with pp[pa] do
      if psc=0 then begin
         ps[0]:=cmd;
         psc:=1
      end else begin
         po[poc]:=ps[psc-1];
         inc(poc);
         ps[psc-1]:=cmd
      end;
   valid:=[1,2,6]
end;

procedure finito;
var
   k: byte;
begin
   if pa<>0 then error;
   with pp[0] do
      if psc<>0 then begin
         for k:=psc-1 downto 0 do
            po[poc-k+psc-1]:=ps[k];
         inc(poc,psc)
      end;
   fine:=true
end;

procedure scriviasm;
var
   vl: byte;
   code: integer;
   ty: string;

procedure fst(k: shortint);
begin
   write(f,#$cd+#$35+char($c0+k))
end;

procedure scrdata;
var
   a: shortint;
begin
   a:=search;
   if a=-1 then begin
      fstack[sc]:=pp[0].po[pa];
      inc(sc);
      if sc=8 then halt;
      val(pp[0].po[pa].value,tmp[vl],code);
      ty:=#$cd+#$3b+#$06+char(lo(ofs(tmp[vl])))+char(hi(ofs(tmp[vl])));
      write(f,ty);
      inc(vl)
   end else fst(a)
end;

procedure scropercon;
begin
   case pp[0].po[pa].value[1] of
      '+': ty:=#$3a+#$c1;
      '/': ty:=#$3a+#$f9;
      '*': ty:=#$3a+#$c9;
      '-': ty:=#$3a+#$fa
   end;
   ty:=#$cd+ty;
   write(f,ty);
   fstack[sc-2].tipo:=0;
   fstack[sc-1].tipo:=0;
   dec(sc)
end;

procedure scropermin;
begin
   with pp[0].po[pa] do
      if value='sin' then ty:=#$35+#$fe else
         if value='cos' then ty:=#$35+#$ff else
            if value='int' then ty:=#$35+#$fc else
               if value='sqrt' then ty:=#$35+#$fa else
                  if value='chs' then ty:=#$35+#$e0 else
                     ty:=#$35+#$e1;
   ty:=#$cd+ty;
   write(f,ty);
   fstack[sc-1].tipo:=0
end;

procedure scrx;
var
   a: shortint;
begin
   a:=search;
   if a=-1 then begin
      fstack[sc]:=pp[0].po[pa];
      inc(sc);
      if sc=8 then halt;
      ty:=#$cd+#$37+#$6e+#$04;
      write(f,ty)
   end else begin
      fst(a);
      fstack[sc].tipo:=0;
      inc(sc)
   end
end;

begin
   assign(f,'f:\rpn.tmp');
   rewrite(f);
   vl:=0;
   ty:=#$8b+#$ec;
   write(f,ty);
   with pp[0] do for pa:=0 to poc-1 do
      case po[pa].tipo of
         1: scrdata;
         3: scropercon;
         4: scropermin;
         6: scrx
      end;
   ty:=#$ca+#$0a+#$00;
   write(f,ty);
   close(f)
end;

begin
   pp[0].poc:=0;
   pp[0].psc:=0;
   fine:=false;
   write('Funzione: ');
   readln(funz);
   funzbis:=funz;
   valid:=[1,2,4,5,6];
   repeat
      searchvalid(cmd);
      if not(cmd.tipo in valid) then error;
      case cmd.tipo of
         1, 6: data;
         2: paraperta;
         3: opercontr;
         4: opermin;
         5: finito;
         7: parchiusa
      end;
      inc(fc,l)
   until fine;
   with pp[0] do for pa:=0 to poc-1 do writeln(po[pa].value);
   scriviasm;
   assign(ff,'f:\rpn.tmp');
   reset(ff,1);
   w:=filesize(ff);
   getmem(obj,w);
   blockread(ff,obj^,w);
   funzione:=funzioni(obj);
   getintvec($35,obj);
   x:=cos(pi);
   write('Quale valore?');
   readln(x);
   writeln('f(x)=',funzione(x))
end.