unit CustomFunction;

interface

uses
  RPNCompiler, ASIConst;

type
  TCustomFunction = class(TFunzione)
  private
    RPN: TRPNCompiler;
  public
    constructor Create(Text: string);
    destructor Destroy; override;
    function Valuta(X: Extended): Extended; override;
  end;

implementation

constructor TCustomFunction.Create(Text: string);
begin
  inherited Create;
  RPN := TRPNCompiler.Create(nil);
  RPN.Text := Text;
end;

destructor TCustomFunction.Destroy;
begin
  RPN.Free;
  inherited Destroy;
end;

function TCustomFunction.Valuta(X: Extended): Extended;
begin
  Result := RPN.Eval([X]);
end;

end.
